import {Workbox} from 'https://storage.googleapis.com/workbox-cdn/releases/4.0.0/workbox-window.prod.mjs';

if ('serviceWorker' in navigator) {
	window.addEventListener('load', () => {
		/*async function addToCache(urls, cacheName) {
			const myCache = await window.caches.open (cacheName);
			await myCache.addAll (urls);
		}*/

		function openModal (modalMsg) {
			$('#modal h2').html (modalMsg);
			$('#modal').dialog ('open');
		}

		const wb = new Workbox ('/service-worker.js');

		wb.addEventListener ('activated', (event) => {
			if (!event.isUpdate) {
				console.log ('Service worker activated for the first time!');
			}
		});

		wb.addEventListener ('waiting', (event) => {
			let modalMsg = 'An updated<br><span class="boss">SERVICE WORKER</SPAN><br>is approaching fast, but it can\'t be encountered until this tab is closed and reopened!';

			openModal (modalMsg);
		});

		wb.register ();
		
		// Playlists are added to cache in vip.js
		//addToCache (['/' + PLAYLISTS['VIP'], '/' + PLAYLISTS['Mellow'], '/' + PLAYLISTS['Exiled']], 'cache-code');

		const updatesChannel = new BroadcastChannel ('api-updates');
		updatesChannel.addEventListener ('message', (event) => {
			const {cacheName, updatedURL} = event.data.payload;
			let filename = updatedURL.split ('/').pop ();

			switch (filename) {
				case ('roster.json'):
				case ('roster.min.json'):
					filename = 'VIP';
					break;
				case ('roster-mellow.json'):
				case ('roster-mellow.min.json'):
					filename = 'VIP MELLOW';
					break;
				case ('roster-exiled.json'):
				case ('roster-exiled.min.json'):
					filename = 'VIP EXILED';
					break;
				case ('index.html'):
				case ('vip.js'):
				case ('vip.min.js'):
				case ('service-worker.mjs'):
				case ('service-worker.min.mjs'):
				case (''):
					filename = 'SOURCE CODE';
					break;
				default:
					filename = 'SOMETHING';
					break;
			}

			console.log (event.data.payload);

			let modalMsg = `An updated<br><span class="boss">${filename}</span><br>is approaching fast!<br>Reload the page to encounter!`;
			openModal (modalMsg);
		});
	});
}
